<template>
  <svn-pro-card
    :clickable="false"
    class="border-[#767680] flex flex-col bg-surface gap-5"
    :class="getClassBySize()"
  >
    <div class="w-full flex items-start gap-4">
      <svn-pro-avatar
        v-if="hasAvatar"
        :size="64"
        :image="userAvatar"
        :type="userAvatar ? 'photo' : 'monogram'"
        :firstname="userName"
        :class="size === SvnProCardSizes.DEFAULT ? 'flex' : 'hidden'"
      />

      <div class="w-full flex flex-col items-start gap-3">
        <div
          class="w-full flex justify-between items-center"
          :class="size === SvnProCardSizes.DEFAULT ? 'flex-1' : 'gap-1'"
        >
          <div class="flex gap-3 items-center">
            <svn-pro-avatar
              v-if="hasAvatar"
              :size="40"
              :image="userAvatar"
              :type="userAvatar ? 'photo' : 'monogram'"
              :firstname="userName"
              :class="size !== SvnProCardSizes.DEFAULT ? 'flex' : 'hidden'"
            />

            <div class="flex flex-col">
              <svn-pro-title
                v-if="size === SvnProCardSizes.DEFAULT"
                bold
                h6
                class="line-clamp-1 break-all"
                color="onSurface"
              >
                {{ userName }}
              </svn-pro-title>

              <svn-pro-text
                v-else
                bold
                body-large
                class="line-clamp-1 break-all"
                color="onSurface"
              >
                {{ userName }}
              </svn-pro-text>

              <svn-pro-text body-medium regular class="line-clamp-1 break-all">
                {{ secondaryInfo }}
              </svn-pro-text>
            </div>
          </div>

          <svn-pro-menu v-if="hasMoreActions" :items="menuItems" menu-class="py-0">
            <template #activator="{ props }">
              <svn-pro-icon-button
                v-bind="props"
                :width="48"
                :height="48"
                color="onSurfaceVariant"
                :icon="'custom:mingcute:more-2-line'"
                :variant="ButtonVariants.text"
              />
            </template>
          </svn-pro-menu>
        </div>

        <div v-if="infotagItems?.length > 0 && showInfoTags" class="flex flex-wrap gap-2">
          <svn-pro-info-tag
            v-for="(app, index) in infotagItems"
            :key="index"
            :text="app?.text"
            :icon="app?.icon"
            :tag-type="InfotagTypes.info"
            :tag-style="InfotagStyles.filled"
            leading-item="icon"
            class="break-all"
            :tag-size="size === SvnProCardSizes.DEFAULT ? 'default' : 'compact'"
          />
        </div>
      </div>
    </div>

    <svn-pro-divider v-if="showDivider" class="border-[#767680]" />

    <div v-if="hasActions" :class="getBottomContentClassBySize()">
      <svn-pro-icon-button
        v-if="size === SvnProCardSizes.COMPACT_SIDE"
        :width="40"
        :height="40"
        :icon="secondaryButton?.icon"
        :variant="ButtonVariants.outlined"
      />

      <svn-pro-button
        v-else
        :text="secondaryButton?.text"
        :variant="ButtonVariants.outlined"
        :prepend-icon="secondaryButton?.icon"
        :block="size === SvnProCardSizes.COMPACT_STACKED"
        @click="secondaryButton?.onClick"
      />

      <svn-pro-button
        :text="primaryButton?.text"
        :variant="ButtonVariants.flat"
        :prepend-icon="primaryButton?.icon"
        :block="size === SvnProCardSizes.COMPACT_STACKED"
        @click="primaryButton?.onClick"
        />
    </div>
  </svn-pro-card>
</template>

<script setup>
import SvnProCard from "../../components/card/SvnProCard.vue";
import SvnProText from "../../components/styles/SvnProText.vue";
import SvnProTitle from "../../components/styles/SvnProTitle.vue";
import SvnProDivider from "../../components/divider/SvnProDivider.vue";
import SvnProAvatar from "../../components/avatar/SvnProAvatar.vue";
import SvnProInfoTag from "../../components/chip/SvnProInfoTag.vue";
import SvnProMenu from "../../components/menu/SvnProMenu.vue";
import SvnProButton from "../../components/button/SvnProButton.vue";
import SvnProIconButton from "../../components/button/SvnProIconButton.vue";
import { SvnProCardSizes, ButtonVariants, InfotagStyles, InfotagTypes } from '../../constants/types.js';

const props = defineProps({
  size: {
    type: String,
    default: SvnProCardSizes.DEFAULT,
  },
  userName: {
    type: String,
    default: '',
  },
  userAvatar: {
    type: String,
    default: '',
  },
  secondaryInfo: {
    type: String,
    default: '',
  },
  hasAvatar: {
    type: Boolean,
    default: true,
  },
  hasActions: {
    type: Boolean,
    default: true,
  },
  showDivider: {
    type: Boolean,
    default: true,
  },
  hasMoreActions: {
    type: Boolean,
    default: true,
  },
  showInfoTags: {
    type: Boolean,
    default: true,
  },
  menuItems: {
    type: Array,
    default: () => [],
  },
  infotagItems: {
    type: Array,
    default: () => [],
  },
  primaryButton: {
    type: Object,
    default: () => {}
  },
  secondaryButton: {
    type: Object,
    default: () => {}
  },
});

const getClassBySize = () => {
  switch (props.size) {
    case SvnProCardSizes.DEFAULT:
      return 'w-full min-w-[400px] max-w-[944px] p-5'
    case SvnProCardSizes.COMPACT_STACKED:
      return 'w-full min-w-[296px] max-w-[480px] p-4'
    case SvnProCardSizes.COMPACT_SIDE:
      return 'w-full min-w-[296px] max-w-[600px] p-4'
    default:
      return ''
  }
}

const getBottomContentClassBySize = () => {
  switch (props.size) {
    case SvnProCardSizes.DEFAULT:
      return 'flex justify-end items-start align-start gap-3 self-stretch flex-wrap'
    case SvnProCardSizes.COMPACT_STACKED:
      return 'flex flex-col items-end gap-3 self-stretch'
    case SvnProCardSizes.COMPACT_SIDE:
      return 'flex justify-end items-start gap-3'
    default:
      return ''
  }
}
</script>